//GAMMA.H
//Sourcecode for DirectDraw Gamma controls.
//(C)'02, Matvej Soloviev ("blackhole89")

#ifndef _GAMMA_H
#define _GAMMA_H

//RestoreNormalGamma: restores normal gamma ;)
void RestoreNormalGamma(LPDIRECTDRAWSURFACE7 lpDDSPrimary)
{
	LPDIRECTDRAWGAMMACONTROL lpgc;
	DDGAMMARAMP ddgr;
	lpDDSPrimary->QueryInterface(IID_IDirectDrawGammaControl,(VOID**)&lpgc);
	for(int i=0;i<256;++i)
	{
		ddgr.blue[i]=i*256;
		ddgr.green[i]=i*256;
		ddgr.red[i]=i*256;
	}
	lpgc->SetGammaRamp(0,&ddgr);
	lpgc->Release();
}

//SetScreenGamma: Sets the screen gamma value (gOf100 means the whole gamma percentage)
void SetScreenGamma(LPDIRECTDRAWSURFACE7 lpDDSPrimary,int gOf100)
{
	RestoreNormalGamma(lpDDSPrimary);
	LPDIRECTDRAWGAMMACONTROL lpgc;
	DDGAMMARAMP ddgr;
	lpDDSPrimary->QueryInterface(IID_IDirectDrawGammaControl,(VOID**)&lpgc);
	lpgc->GetGammaRamp(0,&ddgr);
	for(int i=0;i<256;++i)
	{
		ddgr.blue[i]/=(float)((float)100/(float)gOf100);
		ddgr.green[i]/=(float)((float)100/(float)gOf100);
		ddgr.red[i]/=(float)((float)100/(float)gOf100);
	}
	lpgc->SetGammaRamp(0,&ddgr);
	lpgc->Release();
}

//SetScreenGammaComplex: Allows to set a separate gamma percentage for each colour component
void SetScreenGammaComplex(LPDIRECTDRAWSURFACE7 lpDDSPrimary,int RgOf100,int GgOf100,int BgOf100)
{
	RestoreNormalGamma(lpDDSPrimary);
	LPDIRECTDRAWGAMMACONTROL lpgc;
	DDGAMMARAMP ddgr;
	lpDDSPrimary->QueryInterface(IID_IDirectDrawGammaControl,(VOID**)&lpgc);
	lpgc->GetGammaRamp(0,&ddgr);
	for(int i=0;i<256;++i)
	{
		ddgr.blue[i]/=(float)((float)100/(float)RgOf100);
		ddgr.green[i]/=(float)((float)100/(float)GgOf100);
		ddgr.red[i]/=(float)((float)100/(float)BgOf100);
	}
	lpgc->SetGammaRamp(0,&ddgr);
	lpgc->Release();
}

#endif